from flask import Blueprint, request, redirect, make_response
from . import db
import random
import string

auth = Blueprint('auth', __name__)

ACCESS_TOKEN = ''.join(random.choice(string.ascii_lowercase) for i in range(64))

ERROR_TEXT =  """
              For security-reasons we must make sure you are the person who executed jon :D <br />
              <form action="" method="get">
                  <input type="password" name="token" placeholder="Token" />
                  <input type="hidden" hidden name="next" value="{next}" />
                  <input type="submit" value="login" />
              </form>
              <hr />

              """


def before_request():
    token = request.cookies.get('token')
    if token == ACCESS_TOKEN:
        pass
    else:
        token = request.args.get('token')
        next: str = request.args.get('next') or "/"
        if token is None:
            # TODO: make template
            return ERROR_TEXT.format(next=next) + "No token provided!"
        if token != ACCESS_TOKEN:
            return ERROR_TEXT.format(next=next) + "Invalid token!"
        else:
            resp = make_response(redirect(next))
            resp.set_cookie('token', token)
            return resp


@auth.route('/logout')
def logout():
    resp = make_response(redirect("/"))
    resp.set_cookie('token', "")
    return resp
